﻿using Syncfusion.Data;
using Syncfusion.UI.Xaml.Grid.Cells;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace testUpload
{

    public class CustomAggregate : ISummaryAggregate
    {
        public CustomAggregate()
        {
        }
        public double Checked { get; set; }

        Action<IEnumerable, string, PropertyDescriptor> ISummaryAggregate.CalculateAggregateFunc()
        {
            return (items, property, pd) =>
            {
                var enumerableItems = items as IEnumerable<ClientsOrders>;
                enumerableItems = enumerableItems.Where(x => x.IsChecked).ToArray();
                if (pd.Name == "Checked")
                {
                    this.Checked = enumerableItems.StdDev<ClientsOrders>
                    (bo => bo.TotalOrders);
                }
            };

        }

    }

    public static class LinqExtensions
    {
        public static double StdDev<T>(this IEnumerable<T> values, Func<T, double> selector)
        {
            double assignedpercent = 0;
            var count = values.Count();

            if (count > 0)
            {
                assignedpercent = values.Sum(selector);
            }
            return assignedpercent;
        }
    }
}
